<template>
<div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="告警对象" prop="objId">
        <el-input
            v-model="queryParams.objId"
            placeholder="请输入告警对象"
            clearable
            @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="告警指标" prop="objMetricsId">
        <el-input
            v-model="queryParams.objMetricsId"
            placeholder="请输入告警指标"
            clearable
            @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="告警级别" prop="alarmLevel">
        <el-select v-model="queryParams.alarmLevel" placeholder="请选择告警级别" clearable>
          <el-option
              v-for="dict in alarm_level"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="告警时间" style="width: 308px">
        <el-date-picker
            v-model="daterangeAlarmTime"
            value-format="YYYY-MM-DD"
            type="daterange"
            range-separator="-"
            start-placeholder="开始日期"
            end-placeholder="结束日期"
        ></el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
            type="primary"
            plain
            icon="Plus"
            @click="handleAdd"
            v-hasPermi="['alarm:record:add']"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="success"
            plain
            icon="Edit"
            :disabled="single"
            @click="handleUpdate"
            v-hasPermi="['alarm:record:edit']"
        >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="danger"
            plain
            icon="Delete"
            :disabled="multiple"
            @click="handleDelete"
            v-hasPermi="['alarm:record:remove']"
        >删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="warning"
            plain
            icon="Download"
            @click="handleExport"
            v-hasPermi="['alarm:record:export']"
        >导出
        </el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="recordList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="告警ID" align="center" prop="alarmId"/>
      <el-table-column label="告警对象" align="center" prop="bizobj.objName"/>
      <el-table-column label="告警指标" align="center" prop="bizObjMetrics.metricsName"/>
      <el-table-column label="告警级别" align="center" prop="alarmLevel">
        <template #default="scope">
          <dict-tag :options="alarm_level" :value="scope.row.alarmLevel"/>
        </template>
      </el-table-column>
      <el-table-column label="告警值" align="center" prop="alarmValue" :formatter="rounding"/>
      <el-table-column label="告警时间" align="center" prop="alarmTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.alarmTime, '{y}-{m}-{d} {h}:{mi}:{s}') }}</span>
        </template>
      </el-table-column>
      <!--      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">-->
      <!--        <template #default="scope">-->
      <!--          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['alarm:record:edit']">修改</el-button>-->
      <!--          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['alarm:record:remove']">删除</el-button>-->
      <!--        </template>-->
      <!--      </el-table-column>-->
    </el-table>

    <pagination
        v-show="total>0"
        :total="total"
        v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize"
        @pagination="getList"
    />

    <!-- 添加或修改告警记录对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="recordRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="告警对象;" prop="objId">
          <el-input v-model="form.objId" placeholder="请输入告警对象"/>
        </el-form-item>
        <el-form-item label="告警指标" prop="objMetricsId">
          <el-input v-model="form.objMetricsId" placeholder="请输入告警指标"/>
        </el-form-item>
        <el-form-item label="告警级别" prop="alarmLevel">
          <el-select v-model="form.alarmLevel" placeholder="请选择告警级别">
            <el-option
                v-for="dict in alarm_level"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="告警值" prop="alarmValue">
          <el-input v-model="form.alarmValue" placeholder="请输入告警值"/>
        </el-form-item>
        <el-form-item label="告警时间" prop="alarmTime">
          <el-date-picker clearable
                          v-model="form.alarmTime"
                          type="date"
                          value-format="YYYY-MM-DD"
                          placeholder="请选择告警时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容"/>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Record">
import {addRecord, delRecord, getRecord, listRecord, updateRecord} from "@/api/alarm/record";

const {proxy} = getCurrentInstance();
const {alarm_level} = proxy.useDict('alarm_level');

const recordList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const daterangeAlarmTime = ref([]);

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    objId: null,
    objMetricsId: null,
    alarmLevel: null,
    alarmTime: null,
  },
  rules: {}
});

const {queryParams, form, rules} = toRefs(data);

/** 查询告警记录列表 */
function getList() {
  loading.value = true;
  queryParams.value.params = {};
  if (null != daterangeAlarmTime && '' != daterangeAlarmTime) {
    queryParams.value.params["beginAlarmTime"] = daterangeAlarmTime.value[0];
    queryParams.value.params["endAlarmTime"] = daterangeAlarmTime.value[1];
  }
  listRecord(queryParams.value).then(response => {
    recordList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    alarmId: null,
    objId: null,
    objMetricsId: null,
    alarmType: null,
    alarmLevel: null,
    alarmValue: null,
    alarmTime: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null
  };
  proxy.resetForm("recordRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  daterangeAlarmTime.value = [];
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.alarmId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加告警记录";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _alarmId = row.alarmId || ids.value
  getRecord(_alarmId).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改告警记录";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["recordRef"].validate(valid => {
    if (valid) {
      if (form.value.alarmId != null) {
        updateRecord(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addRecord(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _alarmIds = row.alarmId || ids.value;
  proxy.$modal.confirm('是否确认删除告警记录编号为"' + _alarmIds + '"的数据项？').then(function () {
    return delRecord(_alarmIds);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {
  });
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('alarm/record/export', {
    ...queryParams.value
  }, `record_${new Date().getTime()}.xlsx`)
}

/** 保留2位小数*/
function rounding(row, column) {
  return parseFloat(row[column.property]).toFixed(2)
}

getList();
</script>
